'From Squeak3.1alpha of 9 March 2001 [latest update: #4081] on 1 June 2001 at 6:27:54 pm'!
RectangleMorph subclass: #PlotMorph
	instanceVariableNames: 'title series colors widths drawAxis drawGrid drawCotas drawPoints drawLines form cachedMaxPoint cachedMinPoint xmax xmid xmin ymax ymid ymin xAxeFormatter yAxeFormatter margin keepAspect lens scaledPoints balloonFormatter '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Genetic-Morphs'!
!PlotMorph commentStamp: '<historical>' prior: 0!
I can draw many series of Points in a XY grid!


!PlotMorph methodsFor: 'accessing' stamp: 'DGD 5/27/2001 18:12'!
add: aPlotPoint 
	| points |
	points _ series
				at: aPlotPoint serie
				ifAbsentPut: [OrderedCollection new].
	points
		add: aPlotPoint.
	cachedMaxPoint _ nil.
	cachedMinPoint _ nil.
	"If the morphs has no owner, then the morph is not open yet"
	owner isNil
		ifFalse: [self changed.
			self updateCotas]! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 5/28/2001 00:27'!
balloonFormatter: anObject
	balloonFormatter _ anObject! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 5/30/2001 01:38'!
clear
	series _ Dictionary new.
	cachedMaxPoint _ nil.
	cachedMinPoint _ nil.
	"If the morphs has no owner, then the morph is not open yet"
	owner isNil
		ifFalse: [self changed.
			self updateCotas]! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 12/3/2000 23:03'!
color: aColor 
	
	super color: aColor.
	self updateCotas! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 1/30/2001 20:35'!
drawAxis: anObject 
	anObject = drawAxis
		ifFalse: 
			[drawAxis _ anObject.
			self changed]! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 5/16/2001 18:37'!
drawCotas: anObject 
	anObject = drawCotas
		ifFalse: [drawCotas _ anObject.
			title visible:anObject.
					xmax visible:anObject.
					xmid visible:anObject.
					xmin visible:anObject.
					ymax visible:anObject.
					ymid visible:anObject.
					ymin visible:anObject.
			self changed]!
]style[(11 8 3 8 3 9 13 9 3 8 6 4 24 4 24 4 24 4 24 4 24 4 24 4 22 4 9)f1b,f1cmagenta;ib,f1,f1cmagenta;b,f1,f1cblue;b,f1,f1cblue;b,f1,f1cmagenta;b,f1,f1cblue;b,f1,f1cblue;b,f1,f1cblue;b,f1,f1cblue;b,f1,f1cblue;b,f1,f1cblue;b,f1,f1cblue;b,f1,f1cblue;b,f1! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 12/2/2000 01:53'!
drawGrid: anObject 
	anObject = drawGrid
		ifFalse: 
			[drawGrid _ anObject.
			self changed]! !

!PlotMorph methodsFor: 'accessing' stamp: 'gs 5/11/2001 15:03'!
drawLines: aBoolean 
	aBoolean = drawLines
		ifFalse: [drawLines _ aBoolean.
			self changed]!
]style[(11 8 3 8 3 4 5 13 9 3 8 5 4 9)f1b,f1cmagenta;ib,f1,f1cmagenta;b,f1,f1cblue;b,f1b,f1,f1cblue;b,f1,f1cmagenta;b,f1,f1cblue;b,f1! !

!PlotMorph methodsFor: 'accessing' stamp: 'gs 5/11/2001 15:02'!
drawPoints: aBoolean 


aBoolean = drawPoints
		ifFalse: [drawPoints _ aBoolean.
			self changed]!
]style[(20 2 2 8 3 4 6 13 4 6 3 8 5 4 9)f1b,f1,f1cmagenta;b,f1b,f1,f1cblue;b,f1cmagenta;b,f1,f1cblue;b,f1cmagenta;b,f1,f1b,f1,f1cblue;b,f1! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 5/27/2001 16:47'!
keepAspect: anObject
	keepAspect _ anObject! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 5/26/2001 19:42'!
margin: anObject
	margin _ anObject! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 5/27/2001 18:12'!
serie: aSymbol add: aPoint 
	self 
		add: (PlotPoint at: aPoint serie: aSymbol).
! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 11/30/2000 01:00'!
serie: aSymbol color: aColor
	colors at:aSymbol put: aColor.
	self changed! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 5/16/2001 18:47'!
serie: aSymbol color: aColor width: anInteger 
	colors at: aSymbol put: aColor.
widths at:aSymbol put:anInteger.
	self changed!
]style[(7 7 8 6 8 9 3 6 5 7 6 6 36 4 8)f1b,f1cmagenta;ib,f1b,f1cmagenta;ib,f1b,f1cmagenta;ib,f1,f1cblue;b,f1,f1cmagenta;b,f1,f1cmagenta;b,f1,f1cblue;b,f1! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 5/16/2001 18:47'!
serie: aSymbol width: anInteger 

	widths at: aSymbol put: anInteger.
	self changed!
]style[(7 7 8 9 4 6 5 7 6 9 3 4 8)f1b,f1cmagenta;ib,f1b,f1cmagenta;ib,f1,f1cblue;b,f1,f1cmagenta;b,f1,f1cmagenta;b,f1,f1cblue;b,f1! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 1/10/2001 14:47'!
title:aString
title contents:aString! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 1/30/2001 20:42'!
xAxeFormatter: aFormatterBlock 
	xAxeFormatter _ aFormatterBlock.
	self updateCotas! !

!PlotMorph methodsFor: 'accessing' stamp: 'DGD 1/30/2001 20:40'!
yAxeFormatter: aFormatterBlock 
	yAxeFormatter _ aFormatterBlock.
self updateCotas! !


!PlotMorph methodsFor: 'change reporting' stamp: 'DGD 5/28/2001 02:51'!
changed
	
	form _ nil.
	cachedMaxPoint _ nil.
	cachedMinPoint _ nil.
	super changed! !


!PlotMorph methodsFor: 'drawing' stamp: 'DGD 5/26/2001 19:50'!
drawAxesOn: aCanvas 
	| axesColor yFrom xTo |
	axesColor _ self color twiceLighter.
	"Y axe"
	yFrom _ margin @ 5.
	aCanvas
		line: yFrom
		to: margin @ (self bounds height - 5)
		color: axesColor.
	aCanvas
		line: yFrom
		to: yFrom + (4 @ 4)
		color: axesColor.
	aCanvas
		line: yFrom
		to: yFrom + (-4 @ 4)
		color: axesColor.
	"X axe"
	xTo _ self bounds width - 5 @ (self bounds height - margin).
	aCanvas
		line: 5 @ (self bounds height - margin)
		to: xTo
		color: axesColor.
	aCanvas
		line: xTo
		to: xTo + (-4 @ -4)
		color: axesColor.
	aCanvas
		line: xTo
		to: xTo + (-4 @ 4)
		color: axesColor! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 5/26/2001 19:44'!
drawGridOn: aCanvas 
	| gridColor right bottom width height |
	gridColor _ self color lighter.
	"alpha: 0.5"
	right _ self bounds width - margin.
	width _ self bounds width - (margin * 2).
	bottom _ self bounds height - margin.
	height _ self bounds height - (margin * 2).
	(margin to: right by: width / 10)
		do: [:x | 
			x _ x rounded.
			aCanvas
				line: x @ margin
				to: x @ bottom
				color: gridColor].
	(margin to: bottom by: height / 10)
		do: [:y | 
			y _ y rounded.
			aCanvas
				line: margin @ y
				to: right @ y
				color: gridColor]! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 12/3/2000 19:03'!
drawOn: aCanvas 
	super drawOn: aCanvas.
	
	aCanvas image: self form at: self bounds origin! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 5/28/2001 01:52'!
drawOn: aCanvas serie: aSerie color: aColor width: anInteger 
	| lineColor pointColor lastScaledPoint scaledPoint |
	lineColor _ aColor alpha: 0.8.
	pointColor _ aColor twiceLighter alpha: 0.8.
	lastScaledPoint _ aSerie first scaledPoint.
	aSerie
		do: [:point | 
			scaledPoint _ point scaledPoint.
			drawLines
				ifTrue: [aCanvas
						line: lastScaledPoint
						to: scaledPoint
						width: anInteger
						color: lineColor].
			drawPoints
				ifTrue: [aCanvas
						fillRectangle: (scaledPoint - (1 @ 1) rect: scaledPoint + (2 @ 2))
						color: pointColor].
			lastScaledPoint _ scaledPoint]! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 5/27/2001 18:19'!
form
	| newCanvas |
	form isNil
		ifTrue: [Cursor wait
				showWhile: [""
					self updateCotas.
					self scalePoints.
					form _ Form extent: self bounds extent depth: 32.
					newCanvas _ form getCanvas.
					drawGrid
						ifTrue: [self drawGridOn: newCanvas].
					drawAxis
						ifTrue: [self drawAxesOn: newCanvas].
					series
						keysAndValuesDo: [:serie :points | 
							| serieColor serieWidth | 
									serieColor _ colors
												at: serie
												ifAbsent: [color negated].
									serieWidth _ widths
												at: serie
												ifAbsent: [1].
									self
										drawOn: newCanvas
										serie: points
										color: serieColor
										width: serieWidth]]].
	^ form! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 12/3/2000 21:14'!
maxPoint
	| maxPoint |
	cachedMaxPoint isNil ifTrue: [cachedMaxPoint _ series size = 0
					ifTrue: [0 @ 0]
					ifFalse: 
						[maxPoint _ series anyOne max.
						series valuesDo: [:points | maxPoint _ maxPoint max: points max].
						maxPoint]].
	^ cachedMaxPoint! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 12/3/2000 21:15'!
minPoint
	| minPoint |
	cachedMinPoint isNil ifTrue: [cachedMinPoint _ series size = 0
					ifTrue: [0 @ 0]
					ifFalse: 
						[minPoint _ series anyOne min.
						series valuesDo: [:points | minPoint _ minPoint min: points min].
						minPoint]].
	^ cachedMinPoint! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 5/28/2001 03:10'!
scalePoints
	| scaledExtent |
	scaledPoints _ Dictionary new.
	scaledExtent _ self scaledExtent.
	series
		valuesDo: [:points | 
			self scalePoints: points extent: scaledExtent.
			points
				do: [:point | 
					| all | 
					all _ scaledPoints
								at: point scaledPoint
								ifAbsentPut: [OrderedCollection new].
					all add: point]]! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 5/29/2001 23:30'!
scalePoints: aPointCollection extent: scaledExtent 
	| drawExtent |
	drawExtent _ 1@1 max:(self maxPoint - self minPoint).
	drawExtent isZero
		ifFalse: [aPointCollection
				do: [:point | 
					| tempPoint | 
					tempPoint _ point - self minPoint
								scaleFrom: (0 @ 0 rect: drawExtent)
								to: (margin @ margin rect: scaledExtent - (margin @ margin)).
					point scaledPoint: tempPoint x @ (self height - tempPoint y)]]!
]style[(13 16 9 12 4 11 4 10 12 4 12 4 13 10 20 16 10 7 10 9 9 9 3 5 3 4 30 1 3 1 7 10 15 6 3 6 7 12 4 6 3 6 9 5 14 9 6 4 10 9 5)f1b,f1cmagenta;ib,f1b,f1cmagenta;ib,f1,f1cmagenta;b,f1,f1cmagenta;b,f1,f1cblue;b,f1,f1cblue;b,f1,f1cmagenta;b,f1,f1cmagenta;b,f1,f1cmagenta;i,f1,f1cmagenta;b,f1,f1cmagenta;b,f1,f1cmagenta;b,f1,f1cblue;b,f1,f1c152050000,f1,f1c152050000,f1,f1cmagenta;b,f1,f1cblue;b,f1,f1cblue;b,f1,f1cmagenta;b,f1,f1cblue;b,f1,f1cblue;b,f1,f1cmagenta;b,f1,f1cmagenta;b,f1,f1cblue;b,f1,f1cmagenta;b,f1! !

!PlotMorph methodsFor: 'drawing' stamp: 'DGD 5/28/2001 02:20'!
scaledExtent
	^ keepAspect
		ifTrue: [| drawExtent ratioX ratioY | 
			drawExtent _ self maxPoint - self minPoint.
			ratioX _ drawExtent x / self extent x.
			ratioY _ drawExtent y / self extent y.
			ratioX > ratioY
				ifTrue: [self extent x @ (self extent y * ratioY / ratioX) truncated]
				ifFalse: [(self extent x * ratioX / ratioY) truncated @ self extent y]]
		ifFalse: [self extent]! !

!PlotMorph methodsFor: 'drawing' stamp: 'gs 1/31/2001 22:47'!
updateCotas
	| cotaColor |
	xmax isNil
		ifFalse: 
			[cotaColor _ self color veryMuchLighter.
			title color: cotaColor.
			xmax color: cotaColor.
			xmid color: cotaColor.
			xmin color: cotaColor.
			ymax color: cotaColor.
			ymid color: cotaColor.
			ymin color: cotaColor.
			""
			xmax contents: (xAxeFormatter value: self maxPoint x).
			xmid contents: (xAxeFormatter value: self maxPoint x + self minPoint x / 2).
			xmin contents: (xAxeFormatter value: self minPoint x).
			ymax contents: (yAxeFormatter value: self maxPoint y).
			ymid contents: (yAxeFormatter value: self maxPoint y + self minPoint y / 2).
			ymin contents: (yAxeFormatter value: self minPoint y).
			""
			title position: self topLeft + ((self width - title width / 2) rounded @ 0).
			xmax position: self topLeft + (self width - xmax width - 15 @ (self height - xmax height - 3)).
			xmid position: self topLeft + ((self width - xmid width / 2) rounded @ (self height - xmid height - 3)).
			xmin position: self topLeft + (18 @ (self height - xmin height - 3)).
			ymax position: self topLeft + ((15 - ymax width max: 0)
						@ 15).
			ymid position: self topLeft + ((15 - ymid width max: 0)
						@ (self height - ymid height / 2) rounded).
			ymin position: self topLeft + ((15 - ymin width max: 0)
						@ (self height - ymin height - 15))]! !


!PlotMorph methodsFor: 'event handling' stamp: 'DGD 5/27/2001 01:42'!
handlesMouseDown: evt 
	^ true! !

!PlotMorph methodsFor: 'event handling' stamp: 'DGD 5/30/2001 02:18'!
mouseDown: anEvent 
	| nearPoint |
	series isEmpty
		ifFalse: [Cursor wait
				showWhile: [| targetPoint | 
					targetPoint _ anEvent position - self topLeft.
					nearPoint _ nil.
					scaledPoints
						keysDo: [:scaledPoint | ""
							(nearPoint isNil
									or: [(targetPoint dist: scaledPoint)
											< (targetPoint dist: nearPoint)])
								ifTrue: [nearPoint _ scaledPoint]]]].
	nearPoint isNil
		ifFalse: [anEvent redButtonChanged
				ifTrue: [lens _ EllipseMorph new.
					self addMorph: lens.
					lens
						color: (Color red alpha: 0.5).
					lens extent: 7 @ 7.
					lens position: self topLeft + nearPoint - (3 @ 3).
					lens
						showBalloon: (balloonFormatter
								value: (scaledPoints at: nearPoint))]
				ifFalse: [|extras|
extras _ ((scaledPoints at: nearPoint) collect:[:each | each extra]).
extras _ extras select:[:each | each notNil].
extras size = 1 ifTrue:[extras first explore].
extras size > 1 ifTrue:[extras  explore].



]]! !

!PlotMorph methodsFor: 'event handling' stamp: 'DGD 5/27/2001 21:55'!
mouseUp: anEvent 
	lens isNil
		ifFalse: [lens deleteBalloon.
			lens delete.
			lens _ nil]! !

!PlotMorph methodsFor: 'event handling' stamp: 'DGD 5/27/2001 23:29'!
textForBalloon: aCollection 
	| stream point |
	point _ aCollection anyOne.
	stream _ String new writeStream.
	stream print: point x;
		 nextPut: $@;
		 print: point y;
		 nextPut: Character cr.
	aCollection
		do: [:each | stream nextPutAll: each serie. each extra isNil ifFalse:[stream nextPutAll:': '; print:each extra]]
		separatedBy: [stream nextPut: Character cr].
	^ stream contents! !


!PlotMorph methodsFor: 'geometry' stamp: 'DGD 5/28/2001 02:48'!
extent: aPoint 
	super
		extent: (aPoint max: 100 @ 100)".
	self updateCotas"! !


!PlotMorph methodsFor: 'initialization' stamp: 'DGD 5/28/2001 03:04'!
initialize
	super initialize.
	self color: Color white.
	series _ Dictionary new.
	colors _ Dictionary new.
	widths _ Dictionary new.
	yAxeFormatter _ [:y | y printString].
	xAxeFormatter _ [:x | x printString].
	balloonFormatter _ [:aCollection | self textForBalloon: aCollection].
	drawAxis _ true.
	drawGrid _ true.
	drawCotas _ true.
	drawPoints _ true.
	drawLines _ true.
	margin _ 15.
	keepAspect _ false.
	lens _ nil.
	form _ nil.
	title _ StringMorph contents: ''.
	xmax _ StringMorph contents: ''.
	xmid _ StringMorph contents: ''.
	xmin _ StringMorph contents: ''.
	ymax _ StringMorph contents: ''.
	ymid _ StringMorph contents: ''.
	ymin _ StringMorph contents: ''.
	self addMorph: title.
	self addMorph: xmax.
	self addMorph: xmid.
	self addMorph: xmin.
	self addMorph: ymax.
	self addMorph: ymid.
	self addMorph: ymin! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PlotMorph class
	instanceVariableNames: ''!

!PlotMorph class methodsFor: 'testing' stamp: 'DGD 5/28/2001 01:29'!
test
	" 
	PlotMorph test  
	"
	| pm |
	pm _ PlotMorph new.
	pm
		color: (Color black alpha: 0.8);
		 extent: 300 @ 300;
		 useRoundedCorners.
	pm serie: #sin color: Color red;
		 serie: #cos color: Color blue;
		 serie: #test color: Color yellow.
	0
		to: 360
		by: 10
		do: [:x | 
			pm serie: #sin add: x @ x degreesToRadians sin.
			pm serie: #cos add: x @ x degreesToRadians cos.
			pm serie: #test add: x @ (x degreesToRadians cos + x degreesToRadians sin)].
	pm openInWorld! !

!PlotMorph class methodsFor: 'testing' stamp: 'DGD 5/27/2001 01:31'!
test1
" 
	PlotMorph test1
	"
	| pm |
	pm _ PlotMorph new.
	pm extent: 250 @ 250.
	pm color: Color black.
	pm serie: #raised7 color: Color red.
	pm serie: #raised5 color: Color blue.
	pm serie: #raised3 color: Color yellow.
	pm serie: #raised2 color: Color white.
	1
		to: 100
		do: [:generation | 
			pm serie: #raised7 add: generation @ (1
						- (0.999
								raisedTo: (1 - (generation / 100) raisedTo: 7))).
			pm serie: #raised5 add: generation @ (1
						- (0.999
								raisedTo: (1 - (generation / 100) raisedTo: 5))).
			pm serie: #raised3 add: generation @ (1
						- (0.999
								raisedTo: (1 - (generation / 100) raisedTo: 3))).
			pm serie: #raised2 add: generation @ (1
						- (0.999
								raisedTo: (1 - (generation / 100) raisedTo: 2)))].
	pm openInWorld! !

!PlotMorph class methodsFor: 'testing' stamp: 'gs 1/31/2001 22:58'!
test2
	" 
	PlotMorph test2  
	"
	| pm sigmoid |
	pm _ PlotMorph new.
pm drawPoints:false.
	pm title: 'Sigmoid'.
	pm extent: 250 @ 250.
	pm color: Color black.
	pm serie: #sigmoid1 color: Color red.
	pm serie: #sigmoid2 color: Color blue.
	pm serie: #sigmoid3 color: Color yellow.
	pm serie: #sigmoid4 color: Color green.
	pm serie: #sigmoid5 color: Color white.
	sigmoid _ [:x :slope | 1 / (1 + (slope * x) negated exp)].
	-10
		to: 10
		by: 0.25
		do: 
			[:x | 
			pm serie: #sigmoid1 add: x @ (sigmoid value: x value: 3).
			pm serie: #sigmoid2 add: x @ (sigmoid value: x value: 2).
			pm serie: #sigmoid3 add: x @ (sigmoid value: x value: 1).
			pm serie: #sigmoid4 add: x @ (sigmoid value: x value: 1 / 2).
			pm serie: #sigmoid5 add: x @ (sigmoid value: x value: 1 / 3)].
	pm openInWorld! !

!PlotMorph class methodsFor: 'testing' stamp: 'DGD 6/1/2001 01:02'!
test4
	" 
	PlotMorph test4  
	"
	| pm function |
	pm _ PlotMorph new.
	pm
		color: (Color black alpha: 0.8);
		 extent: 300 @ 300;
		 drawPoints: false;
		 useRoundedCorners.
	pm serie: #test2 color: Color red.
	function _ [:x | x degreesToRadians sin / 5 + ((x / 10) degreesToRadians cos + (x / 10) degreesToRadians sin) * 100].
	0
		to: 3000
		by: 5
		do: [:x | pm serie: #test2 add: x
					@ (function value: x)].
	pm openInWorld! !

!PlotMorph class methodsFor: 'testing' stamp: 'DGD 6/1/2001 18:27'!
test5
	" 
	PlotMorph test5  
	"
	| pm function |
	pm _ PlotMorph new.
	pm
		color: (Color red twiceDarker alpha: 0.8);
		 extent: 300 @ 300;
		 drawPoints: true;
		 useRoundedCorners.
	pm serie: #test color: Color yellow.
	function _ [:x | x degreesToRadians sin / 5 + ((x / 10) degreesToRadians cos + (x / 10) degreesToRadians sin) ].
	0
		to: 3000
		by: 30
		do: [:x | 
			| point | 
			point _ x
						@ (function value: x).
			pm
				add: (PlotPoint
						at: point
						serie: #test
						extra: point)].
	pm openInWorld! !
