'From Squeak3.1alpha of 9 March 2001 [latest update: #4081] on 1 June 2001 at 6:27:48 pm'!
Point subclass: #PlotPoint
	instanceVariableNames: 'serie scaledPoint extra '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Genetic-Morphs'!
!PlotPoint commentStamp: 'DGD 5/27/2001 17:57' prior: 0!
PlotPoint is a point that have more data used to draw in a PlotMorph!


!PlotPoint methodsFor: 'accessing' stamp: 'DGD 5/27/2001 23:29'!
extra
	^extra! !

!PlotPoint methodsFor: 'accessing' stamp: 'DGD 5/27/2001 18:23'!
scaledPoint
	^scaledPoint! !

!PlotPoint methodsFor: 'accessing' stamp: 'DGD 5/27/2001 18:23'!
scaledPoint: anObject
	scaledPoint _ anObject! !

!PlotPoint methodsFor: 'accessing' stamp: 'DGD 5/27/2001 18:12'!
serie
	^serie! !


!PlotPoint methodsFor: 'comparing' stamp: 'DGD 5/27/2001 23:26'!
= anObject 
	^ super = anObject
		and: [serie = self serie and:[extra = self extra]]! !

!PlotPoint methodsFor: 'comparing' stamp: 'DGD 5/27/2001 23:26'!
hash
	^ super hash bitXor: (serie hash bitXor:extra hash)! !


!PlotPoint methodsFor: 'initialization' stamp: 'DGD 5/28/2001 01:41'!
initialize
scaledPoint _ self! !

!PlotPoint methodsFor: 'initialization' stamp: 'DGD 5/27/2001 18:08'!
initializeAt: aPoint serie: aSymbol 
	self setX: aPoint x setY: aPoint y.
	serie _ aSymbol! !

!PlotPoint methodsFor: 'initialization' stamp: 'DGD 5/27/2001 23:24'!
initializeAt: aPoint serie: aSymbol extra:anObject
	self setX: aPoint x setY: aPoint y.
	serie _ aSymbol.
extra _anObject! !


!PlotPoint methodsFor: 'printing' stamp: 'DGD 5/27/2001 23:26'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: ' serie:';
		 nextPutAll: serie;
		 nextPutAll: ' scaled:';
		 print: scaledPoint.
extra isNil ifFalse:[
aStream 
		 nextPutAll: ' extra:';
		 print: extra.
]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

PlotPoint class
	instanceVariableNames: ''!

!PlotPoint class methodsFor: 'instance creation' stamp: 'DGD 5/28/2001 01:41'!
at: aPoint serie: aSymbol 
	^ self new initializeAt: aPoint serie: aSymbol! !

!PlotPoint class methodsFor: 'instance creation' stamp: 'DGD 5/28/2001 01:41'!
at: aPoint serie: aSymbol extra: anObject 
	^ self new
		initializeAt: aPoint
		serie: aSymbol
		extra: anObject! !

!PlotPoint class methodsFor: 'instance creation' stamp: 'DGD 5/28/2001 01:41'!
new
^super new initialize! !
